--- @class Logger

Logger = {}

--- 打印一条Debug日志
--- 
--- @eve_version 1.0
--- @param log string
--- @return nil
function Logger:d(log)
    Log_d(log)
end

--- 打印一条错误日志
--- 
--- @eve_version 1.0
--- @param log string
--- @return nil
function Logger:e(log)
    Log_e(log)
end

--- 上报一条远程CustomEvent埋点, customValue可以是JsonString
--- 
--- @eve_version 1.0
--- @param customKey string
--- @param customValue string
--- @param bizId string
--- @return nil
function Logger:reportCustomEvent(customKey, customValue, bizId)
    local luaBridageParam = {}
    luaBridageParam["customKey"] = customKey
    luaBridageParam["customValue"] = customValue
    if bizId == nil then
        bizId = "EDGE_RECO"
    end
    luaBridageParam["bizId"] = bizId
    return eveCommunicate("reportCustomEvent", luaBridageParam)
end

return Logger
